uva 12097 Pie(二分搜索)

uva 12097 Pie

My birthday is coming up and traditionally I‘m serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets
a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some
pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

Input

One line with a positive integer: the number of test cases. Then for each test case:

  • One line with two integers N and F with 1 ≤ N, F ≤ 10000: the number of pies and the number of friends.
  • One line with N integers ri with 1 ≤ ri ≤ 10000: the radii of the pies.

Output

For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error
of at most 10-3.

Sample Input

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

Sample Output

25.1327
3.1416
50.2655

题目大意:有N个pie,分给F+1个人,使得分给每个人的面积尽量大,每个人分得的pie都是整块的,不能是有几块拼凑起来的。

解题思路:二分答案。

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<algorithm>
using namespace std;
#define Pi 3.141592653589
double S[10005], Max;
int n, f;
int check(double x) { //判断一人x面积派,是否够分
	int sum = 0;
	for (int i = 0; i < n; i++) {
		sum += floor(S[i] / x);
	}
	if (sum >= (f + 1)) return 1;
	else return 0;
}
int main() {
	int	T;
	scanf("%d", &T);
	while (T--) {
		memset(S, 0, sizeof(S));
		scanf("%d %d", &n, &f);
		int a;
		Max = 0;
		for (int i = 0; i < n; i++) {
			scanf("%d", &a);
			S[i] = Pi * a * a;
			Max = max(Max, S[i]);
		}
		double R = Max, L = 0;
		while (R - L > 1e-5) {
			double mid = (R + L) / 2;//二分法,若人均mid够分则向上二分,反之向下二分,知道RL趋近
			if (check(mid)) L = mid;
			else R = mid;
		}
		printf("%.4lf\n", R);
	}
	return 0;
}
时间: 2024-08-02 16:02:19

uva 12097 Pie(二分搜索)的相关文章

HDU 1969 Pie(二分搜索)

题目链接 Problem Description My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie.

uva 12097

题目: http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=42065 #include <cstdio> #include <cmath> using namespace std; const double PI = acos(-1); double v[10005]; int N, F; bool test(double x) { int tot = 0; for(int i=0; i<N; i++) {

HDU1969 Pie(二分搜索)

题目大意是要办生日Party,有n个馅饼,有f个朋友,接下来是n个馅饼的半径.然后是分馅饼了, 注意咯自己也要,大家都要一样大,形状没什么要求,但都要是一整块的那种,也就是说不能从两个饼中 各割一小块来凑一块,像面积为10的和6的两块饼(饼的厚度是1,所以面积和体积相等), 如果每人分到面积为5,则10分两块,6切成5,够分3个人,如果每人6,则只能分两个了! 题目要求我们分到的饼尽可能的大! 只要注意精度问题就可以了,一般WA 都是精度问题 运用2分搜索: 首先用总饼的体积除以总人数,得到每个

uva 12097(二分)

就是二分 #include <iostream> #include <cstdio> #include <algorithm> #include <cstring> #include <cmath> using namespace std; const double pi=acos(-1.0); const int maxn=10000+100; int t,n,f; double a[maxn]; const double esp=1e-5;

Uva 派 (Pie,NWERC 2006,LA 3635)

依然是一道二分查找 1 #include<iostream> 2 #include<cstdio> 3 #include<cmath> 4 using namespace std; 5 6 const double PI=acos(-1.0); 7 int N,F; 8 double r[10001]; 9 10 bool ok(double area) 11 { 12 int sum=0; 13 for(int i=0;i<N;i++) 14 sum+=floo

Pie POJ 3122 二分搜索

Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 17324   Accepted: 5835   Special Judge Description My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of vari

uva 3485 Optimal Array Multiplication Sequence

题目: I - Optimal Array Multiplication Sequence Time Limit:3000MS     Memory Limit:0KB     64bit IO Format:%lld & %llu Submit Status Practice UVA 348 Description Given two arrays A and B, we can determine the array C = AB using the standard definition 

UVA 562 Dividing coins --01背包的变形

01背包的变形. 先算出硬币面值的总和,然后此题变成求背包容量为V=sum/2时,能装的最多的硬币,然后将剩余的面值和它相减取一个绝对值就是最小的差值. 代码: #include <iostream> #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> using namespace std; #define N 50007 int c[102],d

UVA 10341 Solve It

Problem F Solve It Input: standard input Output: standard output Time Limit: 1 second Memory Limit: 32 MB Solve the equation: p*e-x + q*sin(x) + r*cos(x) + s*tan(x) + t*x2 + u = 0 where 0 <= x <= 1. Input Input consists of multiple test cases and te